global NF F antallbit gamma pknm skn sigmakn P1 P2;

%% Initalisering
L = [ 0.5 0.8 ];
NU = length(L);
L_o = min(L);
B = 4.3125*10^-3;
NF = length(F);
Bupstream = 5.2-3.75;
St = -52;
WN = 140;
fext1dB = 45;
Margin = 5;

%% Koeffisientutregning
alpha = 22.5*log(10)/20.*sqrt(F);
gamma = 10^(Margin/10);
sendt = 10^(St/10);
w_kn = 10^(-WN/10);
P1 = sendt*NF;
P2 = sendt*NF;

%% Beregninger
for k=1:NF
    for n=1:NU
        akn(k,n) = exp(-2*alpha(k)*L(n));
        sigmakn(k,n) = w_kn;
        for m=1:NU
            pknm(k,n,m) = exp(-2*alpha(k)*L(m))*10^(-fext1dB/10)*F(k)^2*L_o;
        end
    end
end
for k=1:NF
    for n=1:NU
        for m=1:NU
            for bn=0:antallbit
                for bm=0:antallbit
                    teller(k,n,bn+1,bm+1)=(2^bn-1)*gamma*((2^bm-1)*gamma*pknm(k,n,m)*sigmakn(k,m) + akn(k,m)*sigmakn(k,n));
                    nevner(k,n,bn+1,bm+1)=akn(k,n)*akn(k,n)-(2^bn-1)*(2^bm-1)*gamma^2*pknm(k,n,m)*pknm(k,n,m);
                    skn(k,n,bn+1,bm+1)=(teller(k,n,bn+1,bm+1))/(nevner(k,n,bn+1,bm+1));
                end
            end
        end
    end
end

%% Dual Decomposition
rateteller=0;
for w = 0:0.01:1
    [s1,s2] = optimize_lambda1(w);
	rateteller = rateteller + 1;
    fextsum = pknm(1,1,2)*s2(1);
    rates(1,1) = floor( log2(1+1/gamma*s1(1)/(fextsum+sigmakn(1,1))) );
    fextsum = pknm(1,2,1)*s1(1);
    rates(1,2) = floor( log2(1+1/gamma*s2(1)/(fextsum+sigmakn(1,2))) );
    fextsum = pknm(2,1,2)*s2(2);
    rates(2,1) = floor( log2(1+1/gamma*s1(2)/(fextsum+sigmakn(2,1))) );
    fextsum = pknm(2,2,1)*s1(2);
    rates(2,2) = floor( log2(1+1/gamma*s2(2)/(fextsum+sigmakn(2,2))) );
    fextsum = pknm(3,1,2)*s2(3);
    rates(3,1) = floor( log2(1+1/gamma*s1(3)/(fextsum+sigmakn(3,1))) );
    fextsum = pknm(3,2,1)*s1(3);
	rates(3,2) = floor( log2(1+1/gamma*s2(3)/(fextsum+sigmakn(3,2))) );
	ratebruker1(rateteller) = sum ( rates(:,2) );
	ratebruker2(rateteller) = sum ( rates(:,1) );
end

%% Finne rateregionen
denfinnes=0;
verditeller=1;
verdivektor=0;
rate1verdier = -1;
for temp1=1:rateteller
    for temp2=1:length(rate1verdier)
        if ratebruker1(temp1)==rate1verdier(temp2)
            denfinnes=1;
        end
    end
    if denfinnes==0
        rate1verdier(verditeller)=ratebruker1(temp1);
        verdivektor(verditeller)=temp1;
        verditeller=verditeller+1;
    end
    denfinnes=0;
end
rate1verdier = sort(rate1verdier);
rate2verdier = zeros(1,length(rate1verdier))-1;
for temp3=1:rateteller
    for temp4=1:length(rate1verdier)
        if rate1verdier(temp4)==ratebruker1(temp3)
            if ratebruker2(temp3)>rate2verdier(temp4)
                rate2verdier(temp4)=ratebruker2(temp3);
            end
        end
    end
end
rate1verdier(length(rate1verdier)+1)=rate1verdier(length(rate1verdier));
rate2verdier(length(rate2verdier)+1)=0;
for temp4=1:length(rate2verdier)-1
    if rate2verdier(length(rate2verdier)-temp4)<rate2verdier(length(rate2verdier)+1-temp4)
        rate2verdier(length(rate2verdier)-temp4)=rate2verdier(length(rate2verdier)+1-temp4);
        rate1verdier(length(rate2verdier)-temp4)=rate1verdier(length(rate2verdier)+1-temp4);
    end
end
rate1(1) = 0;
rate2(1) = rate2verdier(1);
for temp5=1:length(rate2verdier)
    rate1(temp5+1)=rate1verdier(temp5);
    rate2(temp5+1)=rate2verdier(temp5);
end