clear all;
global F antallbit epsilon;

%% Initialisering
run = 2;            % EX:1, DD:2, EX & DD:3
plotting = 0;       % Nei:0, Ja:1
B = 4.3125*10^-3;   % Bndbredde delbnd
frekvensvalg = 7;   % Tre f:3, Alle f:0, Annen f:valgfri
epsilon = 10^-10;   % Nyaktighet Lagrange
antallbit = 3;      % Bitloading

%% Forberedelser
if frekvensvalg == 3
    F = [3.9915 4.4745 4.9575];
elseif frekvensvalg == 0
    F = (3.75+B/2 : B : 5.2);
else
    F = (3.75+336/frekvensvalg/2*B : B*336/frekvensvalg : 5.2);
end    
if length(F) < 336
    if antallbit == 3
        tittel = '3 bit/s/Hz/carrier';
        akseverdier = [0 70 0 35];
    elseif antallbit == 5
        tittel = '5 bit/s/Hz/carrier';
        akseverdier = [0 70 0 35];
    elseif antallbit == 7
        tittel = '7 bit/s/Hz/carrier';
        akseverdier = [0 70 0 35];
    elseif antallbit == 10
        tittel = '10 bit/s/Hz/carrier';
        akseverdier = [0 100 0 100];
    elseif antallbit == 12
        tittel = '12 bit/s/Hz/carrier';
        akseverdier = [0 100 0 100];
    elseif antallbit == 15
        tittel = '15 bit/s/Hz/carrier';
        akseverdier = [0 100 0 100];
    end
else
    if antallbit == 10
        tittel = '10 bit/s/Hz/carrier (hele bndet)';
        akseverdier = [0 100 0 100];
    elseif antallbit == 12
        tittel = '12 bit/s/Hz/carrier (hele bndet)';
        akseverdier = [0 100 0 100];
    elseif antallbit == 15
        tittel = '15 bit/s/Hz/carrier (hele bndet)';
        akseverdier = [0 100 0 100];
    end
end

%% Simulering og plot
start_tid = clock;
if run == 1
    % Exhaustive Search
    exhaustive;
    stopp_tid = clock;
    if plotting == 1
        set(gcf,'DefaultLineLineWidth',1);
        set(gcf,'DefaultAxesFontSize',14);
        hold on;
        grid on;
        xlabel('Datarate bruker 1 (kort), Mbps');
        ylabel('Datarate bruker 2 (lang), Mbps');
        plot(rate1verdier,rate2verdier,'--');
        plot(ratebruker1,ratebruker2,'rx');
        legend('OSM: Ex.search','Punkter funnet','location','northeast')
        axis(akseverdier);
        title(tittel);
    end
elseif run == 2
    % Dual Decomposition
    dualdec; 
    stopp_tid = clock;
    if plotting == 1
        set(gcf,'DefaultLineLineWidth',1);
        set(gcf,'DefaultAxesFontSize',14);
        hold on;
        grid on;
        xlabel('Datarate bruker 1 (kort), Mbps');
        ylabel('Datarate bruker 2 (lang), Mbps');
        plot(rate1,rate2);
        plot(ratebruker1,ratebruker2,'rx');
        legend('OSM: Dual Dec.','Punkter funnet','location','northeast')
        axis(akseverdier);
        title(tittel);
    end
elseif run == 3
    exhaustive;
    ex1 = rate1verdier;
    ex2 = rate2verdier;
    dualdec;
    dd1 = rate1;
    dd2 = rate2;
    stopp_tid = clock;
    if plotting == 1
        set(gcf,'DefaultLineLineWidth',1)   %  Default line size
        set(gcf,'DefaultAxesFontSize',14)   %  Default axis font size 
        hold on;
        grid on;
        xlabel('Datarate bruker 1 (kort), Mbps');
        ylabel('Datarate bruker 2 (lang), Mbps');
        plot(dd1,dd2);
        plot(ex1,ex2,'--');
        legend('OSM: Dual Dec.','OSM: Ex.search','location','northeast')
        axis(akseverdier);
        title(tittel);
    end
end
brukt_tid = stopp_tid - start_tid;
brukt_tid_sekunder = brukt_tid(5)*60 + brukt_tid(6)